#include "shade.h"

shade::shade(RNG *rng, const position &pos):
        character{rng, race::rshade, pos} {
        gold = 0;
        hostile = true;
}

result shade::attack(const direction dir, character_list &chlist) {
        position tmp{pos + MOVE[dir]};

        for (auto &ch : chlist)
                if (tmp == ch->get_position()) {
                        return ch->get_hit(race, ATK, base_hit_rate);
                }

        return result::fine;
}

result shade::get_hit(const enum race &race, const int atk,
                      const fraction hitrate) {
        if (rng->trial(hitrate)) // This is a hit!
                HP = std::max(HP - calc_dmg(atk, DEF), 0);

        if (HP == 0)
                return result::died;

        return result::hit;
}

